#!/bin/bash

# TODO: improve me



. download_files

INCLUDE_ZOPE_PLONE=""
for arg in $@
do
	if [ "$arg" = "--include_zope_and_plone=yes" ] ; then
		INCLUDE_ZOPE_PLONE="yes"
	fi

	if [ "$arg" = "--include_zope_and_plone=no" ] ; then
		INCLUDE_ZOPE_PLONE="no"
	fi
done

if [ "$INCLUDE_ZOPE_PLONE" = "" ] ; then
	echo 'please define "include_zope_and_plone" as yes or no'
	echo "(zope and plone are not used if building clustermon only)"
	echo " eg: $0 --include_zope_and_plone=yes" 
	exit 1
fi

get_and_verify_archive()
{
	NAME=$1
	SHA512SUM=$2
	shift 2
	URLs=$@

	if [ ! -e $NAME ] ; then
		echo ; echo "$NAME not present, download it"
		done="false"
		for url in $URLs
		do
			if [ "$done" = "false" ] ; then
				echo "Downloading $NAME from $url"
				wget $url
				if [ "$?" = "0" ] ; then
					echo "$SHA512SUM  $NAME" | /usr/bin/sha512sum --check --status >/dev/null 2>/dev/null
					if [ "$?" = "0" ] ; then
						echo "$NAME passed sha512sum test"
						done="true"
					else
						echo "$NAME failed sha512sum test"
						rm -f $NAME
						echo "Trying next mirror in the list..."
					fi
				else
					rm -f $NAME
					echo "Trying next mirror in the list..."
				fi
			fi
		done

		if [ "$done" = "false" ] ; then
			echo "No more mirrors to download $NAME from. exiting..."
			exit 5
		fi
	else
		echo "$SHA512SUM  $NAME" | /usr/bin/sha512sum --check --status >/dev/null 2>/dev/null
		if [ "$?" = "0" ] ; then
			echo "$NAME passed sha512sum test"
		else
			echo "$NAME failed sha512sum test; remove it and try again"
			exit 6
		fi
	fi
}

if [ "$INCLUDE_ZOPE_PLONE" = "yes" ] ; then
	get_and_verify_archive \
	$ZOPE_ARCHIVE_TAR \
	$ZOPE_SHA512SUM \
	$ZOPE_URLs
	get_and_verify_archive \
	$PLONE_ARCHIVE_TAR \
	$PLONE_SHA512SUM \
	$PLONE_URLs
fi

. make/version.in

cat conga.spec.in.in \
	| sed -e s/@@VERS@@/$VERSION/g \
	| sed -e s/@@REL@@/$RELEASE/g \
	| sed -e s/@@INCLUDE_ZOPE_AND_PLONE@@/$INCLUDE_ZOPE_PLONE/g \
	| sed -e s/@@ZOPE_ARCHIVE@@/$ZOPE_ARCHIVE/g \
	| sed -e s/@@ZOPE_ARCHIVE_TAR@@/$ZOPE_ARCHIVE_TAR/g \
	| sed -e s/@@PLONE_ARCHIVE@@/$PLONE_ARCHIVE/g \
	| sed -e s/@@PLONE_ARCHIVE_TAR@@/$PLONE_ARCHIVE_TAR/g \
	> conga.spec

cat clustermon.spec.in.in \
	| sed -e s/@@VERS@@/$VERSION/g \
	| sed -e s/@@REL@@/$RELEASE/g \
	> clustermon.spec

cat ricci.spec.in.in \
	| sed -e s/@@VERS@@/$VERSION/g \
	| sed -e s/@@REL@@/$RELEASE/g \
	> ricci.spec

cd ricci ; ./autogen.sh $@ ; cd ..
cd luci ; ./autogen.sh $@ ; cd ..

echo ""
echo "Run \`./configure\` to configure conga build,"
echo "or \`make srpms\` to build conga and clustermon srpms"
echo "or \`make rpms\` to build all rpms"
