from distutils.core import setup, Extension

module1 = Extension('conga_ssl_lib',
	define_macros = [('MAJOR_VERSION', '0'), ('MINOR_VERSION', '12')],
	include_dirs = ['../../ricci/include', '/usr/include/libxml2'],
	libraries = ['ssl', 'xml2'],
	sources = [
		'conga_ssl_lib.cpp',
		'SSLClient.cpp',
		'../../ricci/common/ClientSocket.cpp',
		'../../ricci/common/Socket.cpp',
		'../../ricci/common/Network.cpp',
		'../../ricci/common/Logger.cpp',
		'../../ricci/common/Time.cpp',
		'../../ricci/common/File.cpp',
		'../../ricci/common/XML.cpp',
		'../../ricci/common/utils.cpp',
		'../../ricci/common/sys_util.c',
		'../../ricci/common/executils.cpp'])

setup (name = 'conga_ssl_lib',
		version = '0.12',
		description = 'SSL Python bindings for Conga',
		author = 'Red Hat, Inc.',
		author_email = 'rmccabe@redhat.com',
		license = 'GPL',
		url = 'http://www.sourceware.org/cluster/conga',
		long_description = '''
		conga_ssl_lib
		''',
		ext_modules = [module1])
