#!/usr/bin/python

##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
# Copyright (C) 2006-2008 Red Hat, Inc.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL). A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################
usage=""" [options] url file .....
      -D
         For HTML documents, replace the start of the content, up to
         and including the opening body tag with a DTML var tag that
         inserts the standard header. Also replace the closing body
         and html tag with a DTML var tag that inserts the standard
         footer.

      -I                  For each index.html, add an index_html that redirects.
      -p <path>           Path to ZPublisher.
      -u <user:password>  Credentials
      -v                  Run in verbose mode.
"""

import sys, getopt, os, string
ServerError=''
verbose=0
doctor=0
index_html=0

sys.path.extend((
	'/usr/lib/luci/zope/lib/python',
	'/usr/lib/luci/zope/lib/python/Products',
	'/usr/lib64/luci/zope/lib/python',
	'/usr/lib64/luci/zope/lib/python/Products',
	'/usr/lib64/luci/zope/lib64/python',
	'/usr/lib64/luci/zope/lib64/python/Products',
	'/usr/lib64/zope/lib64/python',
	'/usr/lib64/zope/lib/python',
	'/usr/lib/zope/lib/python',
	'/usr/lib64/zope/lib/python/Products',
	'/usr/lib64/zope/lib64/python/Products',
	'/usr/lib/zope/lib/python/Products'
))

from Products import __path__
for i in ['/usr/lib/luci/zope/lib/python/Products',
	'/usr/lib64/luci/zope/lib/python/Products',
	'/usr/lib64/luci/zope/lib64/python/Products',
	'/usr/lib64/zope/lib/python/Products',
	'/usr/lib64/zope/lib64/python/Products',
	'/usr/lib/zope/lib/python/Products']:
	if os.path.isdir(i):
		__path__.append(i)

import ZPublisher.Client

def main():
	user, password = 'admin', 'changeme'
	opts, args = getopt.getopt(sys.argv[1:], 'p:u:DIv9')
	global verbose
	global doctor
	global index_html
	havepath=None

	for o, v in opts:
		if o=='-p':
			d, f = os.path.split(v)
			if f=='ZPublisher': sys.path.insert(0,d)
			else: sys.path.insert(0,v)
			havepath=1
		elif o=='-u':
			v = string.split(v,':')
			user, password = v[0], string.join(v[1:],':')
		elif o=='-D': doctor=1
		elif o=='-I': index_html=1
		elif o=='-v': verbose=1

	if not args:
		print sys.argv[0]+usage
		sys.exit(1)

	if not havepath:
		here=os.path.split(sys.argv[0])[0]
		if os.path.exists(os.path.join(here,'ZPublisher')):
			sys.path.insert(0,here)
		else:
			here=os.path.split(here)[0]
			here=os.path.join(here,'lib','python')
			if os.path.exists(os.path.join(here,'ZPublisher')):
				sys.path.insert(0,here)


	url=args[0]
	files=args[1:]

	import ZPublisher.Client
	global ServerError
	ServerError=ZPublisher.Client.ServerError
	object=ZPublisher.Client.Object(url, username=user, password=password)

	for f in files: upload_file(object, f)

def call(f, *args, **kw):
	# Call a function ignoring redirect bci errors.
	try: apply(f,args, kw)
	except ServerError, v:
		if str(v)[:1] != '3':
			raise sys.exc_info()[0], sys.exc_info()[1], sys.exc_info()[2]

def upload_file(object, f):
	if os.path.isdir(f): return upload_dir(object, f)
	dir, name = os.path.split(f)
	root, ext = os.path.splitext(name)
	if ext in ('file', 'dir'): ext=''
	else:
		ext=string.lower(ext)
		if ext and ext[0] in '.': ext=ext[1:]
	if ext and globals().has_key('upload_'+ext):
		if verbose: print 'upload_'+ext, f
		return globals()['upload_'+ext](object, f)

	if verbose: print 'Defaulting to page templage type for', f
	return upload_pt(object, f)

def upload_dir(object, f):
	dir, name = os.path.split(f)
	call(object.manage_addFolder, id=name)
	object=object.__class__(object.url+'/'+name,
							username=object.username,
							password=object.password)

	for n in os.listdir(f):
		upload_file(object, os.path.join(f,n))

def upload_txt(object, f, t='text/plain'):
	dir, name = os.path.split(f)

	try:
		call(object.manage_addFile, id=name, file=open(f,'rb'), content_type=t)
		if verbose:
			print 'Uploaded', name
	except:
		if verbose:
			print name, 'exists trying to delete then upload again'
		try:
			call(object.manage_delObjects, ids=[name])
			if verbose: print 'Uploaded', name
			try:
				call(object.manage_addFile, id=name, file=open(f,'rb'), content_type=t)
				if verbose: print 'Uploaded', name
			except: print 'Unable to upload', name
		except: print 'Unable to delete', name

def upload_css(object, f):
	upload_txt(object, f, t='text/css')

def upload_js(object, f):
	upload_txt(object, f, t='text/javascript')

def upload_vpy(object, f):
	dir, name = os.path.split(f)

	nobject = object.__class__(object.url+'/manage_addProduct/CMFFormController',
							username=object.username,
							password=object.password)

	dbid = name.split('.')[0]

	try:
		raise Exception, 'Not supported'
		#call(nobject.manage_addControllerPythonScript, id=dbid, file=open(f,'rb'))
		#if verbose: print 'Uploaded', dbid
	except:
		if verbose: print name, 'exists trying to delete then upload again'
		try:
			call(object.manage_delObjects, ids=[dbid])
			if verbose: print 'Deleted', dbid
			try:
				raise Exception, 'Not supported'
				#call(nobject.manage_addControllerPythonScript, id=dbid, file=open(f,'rb'))
				#if verbose: print 'Uploaded', dbid
			except: print 'Unable to upload', dbid
		except: print 'Unable to delete', dbid

def upload_cpt(object, f):
	dir, name = os.path.split(f)

	nobject = object.__class__(object.url+'/manage_addProduct/CMFFormController',
							username=object.username,
							password=object.password)

	dbid = name.split('.')[0]

	try:
		raise Exception, 'Not supported'
		#call(nobject.manage_addControllerPageTemplate, id=dbid, file=open(f,'rb'))
		#if verbose: print 'Uploaded', dbid
	except:
		if verbose: print name, 'exists trying to delete then upload again'
		try:
			call(object.manage_delObjects, ids=[dbid])
			if verbose: print 'Deleted', dbid
			try:
				raise Exception, 'Not supported'
				#call(nobject.manage_addControllerPageTemplate, id=dbid, file=open(f,'rb'))
				#if verbose: print 'Uploaded', dbid
			except:
				print 'Unable to upload', dbid
		except: print 'Unable to delete', dbid

def upload_pt(object, f):
	dir, name = os.path.split(f)

	nobject = object.__class__(object.url+'/manage_addProduct/PageTemplates',
							username=object.username,
							password=object.password)

	dbid = name.split('.')[0]

	try:
		call(nobject.manage_addPageTemplate, id=dbid, file=open(f,'rb'))
		if verbose: print 'Uploaded', dbid
	except:
		if verbose: print name, 'exists trying to delete then upload again'
		try:
			call(object.manage_delObjects, ids=[dbid])
			if verbose: print 'Deleted', dbid
			try:
				call(nobject.manage_addPageTemplate, id=dbid, file=open(f,'rb'))
				if verbose: print 'Uploaded', dbid
			except: print 'Unable to upload', dbid
		except: print 'Unable to delete', dbid

from sgmllib import SGMLParser

def join_attrs(attrs):
	attr_list = []
	for attrname, value in attrs:
		attr_list.append('%s="%s"' % (attrname, string.strip(value)))

	if attr_list:
		s = " " + string.join(attr_list, " ")
	else:
		s = ""

	return s


class HeadParser(SGMLParser):
	def __init__(self):
		SGMLParser.__init__(self)

		self.seen_starthead = 0
		self.seen_endhead	= 0
		self.seen_startbody = 0

		self.head = ""
		self.title = ""
		self.accumulator = ""


	def handle_data(self, data):
		if data:
			self.accumulator = self.accumulator + data

	def handle_charref(self, ref):
		self.handle_data("&#%s;" % ref)

	def handle_entityref(self, ref):
		self.handle_data("&%s;" % ref)

	def handle_comment(self, data):
		if data:
			self.accumulator = self.accumulator + "<!--%s-->" % data


	def start_head(self, attrs):
		if not self.seen_starthead:
			self.seen_starthead = 1
			self.head = ""
			self.title = ""
			self.accumulator = ""

	def end_head(self):
		if not self.seen_endhead:
			self.seen_endhead = 1
			self.head = self.head + self.accumulator
			self.accumulator = ""


	def start_title(self, attrs):
		self.head = self.head + self.accumulator
		self.accumulator = ""

	def end_title(self):
		self.title = self.accumulator
		self.accumulator = ""


	def start_body(self, attrs):
		if not self.seen_startbody:
			self.seen_startbody = 1
			self.accumulator = ""

	def end_body(self): pass # Do not put </BODY> and </HTML>
	def end_html(self): pass # into output stream


	# Pass other tags unmodified
	def unknown_starttag(self, tag, attrs):
		self.accumulator = self.accumulator + "<%s%s>" % (string.upper(tag), join_attrs(attrs))

	def unknown_endtag(self, tag):
		self.accumulator = self.accumulator + "</%s>" % string.upper(tag)


def parse_html(infile):
	parser = HeadParser()

	while 1:
		line = infile.readline()
		if not line: break
		parser.feed(line)

	parser.close()
	infile.close()

	return (string.strip(parser.title), string.strip(parser.head),
			string.strip(parser.accumulator))


def upload_html(object, f):
	dir, name = os.path.split(f)
	f=open(f)

	if doctor:
		title, head, body = parse_html(f)
		body = ("<dtml-var standard_html_header>\n\n" +
				body + "\n\n<dtml-var standard_html_footer>")

	else:
		title, head, body = '', '', f

	try:
		call(object.manage_addDTMLDocument, id=name, title=title, file=body)
		if verbose: print 'Uploaded', name
	except:
		if verbose: print name, 'exists trying to delete then upload again'
		try:
			call(object.manage_delObjects, ids=[name])
			if verbose: print 'Deleted', name
			try:
				call(object.manage_addDTMLDocument, id=name, title=title, file=body)
				if verbose: print 'Uploaded', name
			except: print 'Unable to upload', name
		except: print 'Unable to delete', name

	if index_html and name in ('index.html', 'index.htm'):
		call(object.manage_addDTMLMethod, id='index_html',
			 file=('<dtml-raise Redirect>'
					'<dtml-var URL1>/%s'
					'</dtml-raise>' % name))

	# Now add META and other tags as property
	if head:
		object=object.__class__(object.url+'/'+name,
				username=object.username,
				password=object.password)

		call(object.manage_addProperty,
			 id="loadsite-head", type="text", value=head)

# ----- /phd -----

upload_htm=upload_html

def upload_dtml(object, f):
	dir, name = os.path.split(f)
	f=open(f, 'rb')

	try:
		db_id = name.split('.')
		db_id_len = len(db_id)
		if db_id_len > 2 and db_id[db_id_len - 2] != 'dtml':
			db_id = apply(lambda x,y: x + '.' + y, db_id[:-1])
		name = db_id
	except: pass
	contents = f.read()

	try:
		call(object.manage_addDTMLMethod, id=name, file=contents)
		if verbose: print 'Uploaded', name
	except:
		if verbose: print name, 'exists trying to delete then upload again'
		try:
			call(object.manage_delObjects, ids=[name])
			if verbose: print 'Deleted', name
			try:
				call(object.manage_addDTMLMethod, id=name, file=contents)
				if verbose: print 'Uploaded', name
			except: print 'Unable to upload', name
		except: print 'Unable to delete', name

def upload_gif(object, f):
	dir, name = os.path.split(f)

	try:
		call(object.manage_addImage, id=name, file=open(f,'rb'))
		if verbose: print 'Uploaded', name
	except:
		if verbose: print name, 'exists trying to delete then upload again'
		try:
			call(object.manage_delObjects, ids=[name])
			if verbose: print 'Deleted', name
			try:
				call(object.manage_addImage, id=name, file=open(f,'rb'))
				if verbose: print 'Uploaded', name
			except: print 'Unable to upload', name
		except: print 'Unable to delete', name

upload_jpg=upload_gif
upload_png=upload_gif
upload_ico=upload_gif

if __name__=='__main__': main()
