#! /usr/bin/env python

#  Copyright (C) Red Hat, Inc. 2007-2008
#
#  This program is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License as published by the
#  Free Software Foundation; either version 2, or (at your option) any
#  later version.
#
#  This program is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; see the file COPYING.  If not, write to the
#  Free Software Foundation, Inc.,  675 Mass Ave, Cambridge, 
#  MA 02139, USA.

'''
Script name:    cleaner.py
Creation date:  Feb 2007
Purpose:        Prototype automated GUI test for RHEL5 Conga (luci server web app) - automated
                with Selenium RC (remote control) 0.9.0
Summary:        Script to clean up all Conga test suite related artifacts - this script will be 
                before Conga use case tests
'''

__author__ = 'Len DiMaggio <ldimaggi@redhat.com>'

from selenium import selenium
import unittest, time, re
from conga_Helpers import *
import time
import logging
from loggerObject import loggerObject

class cleaner:
    
    def cleanup(self):

        selenium = login (CONGA_ADMIN_USERNAME, CONGA_ADMIN_PASSWORD)
        sel = selenium
        theloggerObject = setupLogger (CONGA_DEBUG_LOG)
        logger = theloggerObject.getLogger()
        
        # Step 1 of 3 - Delete all clusters
        sel.click("link=homebase")
        sel.wait_for_page_to_load(PAGE_DISPLAY_DELAY)
        sel.click("link=cluster")
        sel.wait_for_page_to_load(PAGE_DISPLAY_DELAY)
                
        tempBool = sel.is_element_present("cluster_action")
        if (tempBool == True):
            sel.select("cluster_action", "label=Delete this cluster")
            sel.click("//input[@value='Go']")
            sel.wait_for_page_to_load(PAGE_DISPLAY_DELAY)
            time.sleep(300)
        else:
            print 'No cluster to delete'
           
        sel.click("link=homebase")
        
        # Create the users
#        for userName in CONGA_USERS.keys(): 
#            createUser (sel, userName, CONGA_USERS[userName], logger)
#            # Validation - verify that the success message was displayed for each user
#            assertEqual('Do you really want to add the user "' + userName + '"?', sel.get_confirmation())
#            sel.wait_for_page_to_load(PAGE_DISPLAY_DELAY)
#            assertTrue (sel.is_text_present('Added new user "' + userName + '" successfully')) 
#     
###############################################################################
        # Delete the users 
        for userName in CONGA_USERS.keys(): 
            deleteUser (sel, userName, logger)
            # Validation - verify that the success message was displayed for each user
            try:
                assertEqual('Do you really want to remove the user "' + userName + '"?', sel.get_confirmation())
                sel.wait_for_page_to_load(PAGE_DISPLAY_DELAY)
                assertTrue (sel.is_text_present('User "' + userName + '" has been deleted'))  
            except:
                print 'Unable to delete user: ' + userName + ' does it exist?'
    
        
#        # Create the storage systems
#        for systemName in CONGA_STORAGE_SYSTEMS:
#            createStorageSystem(sel, systemName, CONGA_STORAGE_SYSTEMS[systemName], logger)
#            # Validation - verify that the success message was displayed for each storage system
#            assertEqual("Do you really want to add the following Storage Systems:\n" + systemName, sel.get_confirmation())
#            sel.wait_for_page_to_load(PAGE_DISPLAY_DELAY)
#            assertTrue (sel.is_text_present('Added storage system "' + systemName + '" successfully'))            
#            

        tempBool = sel.is_element_present("link=Manage Systems")
        if (tempBool == True):
             # Delete the storage systems
            for systemName in CONGA_STORAGE_SYSTEMS:
                deleteStorageSystem(sel, systemName, logger)
                try:
                    # Validation - verify that the success message was displayed for each storage system
                    assertEqual("Do you really want to remove the following managed systems:\nStorage Systems:\n-" + systemName, sel.get_confirmation())
                    sel.wait_for_page_to_load(PAGE_DISPLAY_DELAY)
                    assertTrue (sel.is_text_present('Removed storage system "' + systemName + '" successfully'))
                except:
                    print 'Unable to delete system: ' + systemName + ' does it exist?'
        else:
            print 'No systems to delete'
           
        sel = selenium.stop()
             
