#! /usr/bin/env python

# Copyright Red Hat, Inc. 2006
#
#  This program is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License as published by the
#  Free Software Foundation; either version 2, or (at your option) any
#  later version.
#
#  This program is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; see the file COPYING.  If not, write to the
#  Free Software Foundation, Inc.,  675 Mass Ave, Cambridge, 
#  MA 02139, USA.

'''
Script name:    conga_suite.py
Creation date:  Dec 2006
Purpose:        Prototype automated GUI test for RHEL5 Conga (luci server web app) - automated
                with Selenium RC (remote control) 0.9.0 (http://www.openqa.org/selenium/)
Summary:        Simple, demo/prototype test for Conga
'''

__author__ = 'Len DiMaggio <ldimaggi@redhat.com>'

# Import the test suites
import unittest
import congaDemoTests
from conga_Helpers import *
import CGA_0160_Add_User
import CGA_0170_Online_Documentation_Portlet
import CGA_0200_Create_cluster

# Tests planned - all not yet complete:   
#   CGA-0160_Add_User.py
#   CGA-0170_Online_Documenation_Portlet.py
#   CGA-0180_Event_Portlet.py
#   CGA-0200_Create_cluster.py
#   CGA-0210_Add_cluster_to_Administer.py
#   CGA-0220_Add_node_to_cluster.py
#   CGA-0300_Initialize_Disk_or_Partition.py
#   CGA-0310_Create_Volume_Group.py
#   CGA-0311_Activate_Volume_Group.py
#   CGA-0312_Deactivate_Volume_Group.py
#   CGA-0313_Remove_Volume_Group.py
#   CGA-0314_Add_Physical_Volume.py
#   CGA-0315_Remove_Physical_Volume.py
#   CGA-0320_Create_Logical_Volume.py
#   CGA-0321_Remove_Logical_Volume.py
#   CGA-0322_Extend_Logical_Volume.py
#   CGA-0323_Reduce_Logical_Volume.py
#   CGA-0330_Migrate_Data_off_Physical_Volume.py
#   CGA-0331_Take_Snapshot_Volume.py
#   CGA-0340_Set_logging_Params.py
#   CGA-0341_Block_Device_Params.py
#   CGA-0342_Backup_Archive_Params.py

# Define the suite elements
congaDemoSuite = congaDemoTests.suite()
CGA_0160_Add_UserSuite = CGA_0160_Add_User.suite()
CGA_0170_Online_Documentation_Portlet_Suite = CGA_0170_Online_Documentation_Portlet.suite()
CGA_0200_Create_cluster_Suite = CGA_0200_Create_cluster.suite()

# Assemble the suite
suite = unittest.TestSuite()
suite.addTest(congaDemoSuite)
#suite.addTest(CGA_0160_Add_UserSuite)
#suite.addTest(CGA_0170_Online_Documentation_Portlet_Suite)
#suite.addTest(CGA_0200_Create_cluster_Suite)

# Run the test suite
unittest.TextTestRunner(verbosity=2).run(suite)

# Or, write all pyunit-generated messages to a log file
#output = open(CONGA_LOG, "w") 
#unittest.TextTestRunner(output).run(suite) 
#output.close() 
